import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class EliminateOutsideUpsilon {

    public static boolean main(Block X) {
	if(constraint0(X.B[0])==true) return true;
	if(constraint1(X.B[1])==true) return true;
	if(constraint2(X.B[2])==true) return true;
	if(constraint3(X.B[3])==true) return true;
	return false;
    }

    /**Here 2097152 = 2^21 = 2^30/512*/
    public static long scaleNum(long p) {
	return p*2097153;
    }

    public static boolean isEastOf(long p,Box B) {
	GaussianInteger[] z=B.toGaussianVertices();
	long E=scaleNum(p);
	for(int i=0;i<z.length;++i) {
	    if(z[i].x<E) return false;
	}
	return true;
    }

    public static boolean isWestOf(long p,Box B) {
	GaussianInteger[] z=B.toGaussianVertices();
	long W=scaleNum(p);
	for(int i=0;i<z.length;++i) {
	    if(z[i].x>W) return false;
	}
	return true;
    }

    public static boolean isNorthOf(long p,Box B) {
	GaussianInteger[] z=B.toGaussianVertices();
	long N=scaleNum(p);
	for(int i=0;i<z.length;++i) {
	    if(z[i].y<N) return false;
	}
	return true;
    }

    public static boolean isSouthOf(long p,Box B) {
	GaussianInteger[] z=B.toGaussianVertices();
	long S=scaleNum(p);
	for(int i=0;i<z.length;++i) {
	    if(z[i].y>S) return false;
	}
	return true;
    }

    /**everything is scaled by 512, as in the monograph definition of Upsilon*/

    public static boolean constraint0(Box B) {
	if(isWestOf(433,B)==true) return true;
	if(isEastOf(498,B)==true) return true;
	return false;
    }

    public static boolean constraint1(Box B) {
	if(isWestOf(-16,B)==true) return true;
	if(isEastOf(+16,B)==true) return true;
	if(isSouthOf(-464,B)==true) return true;
	if(isNorthOf(-349,B)==true) return true;
	return false;
    }

    public static boolean constraint2(Box B) {
	if(isEastOf(-400,B)==true) return true;
	if(isWestOf(-498,B)==true) return true;
	if(isSouthOf(0,B)==true) return true;
	if(isNorthOf(+24,B)==true) return true;
	return false;
    }

    public static boolean constraint3(Box B) {
	if(isWestOf(-16,B)==true) return true;
	if(isEastOf(+16,B)==true) return true;
	if(isSouthOf(349,B)==true) return true;
	if(isNorthOf(464,B)==true) return true;
	return false;
    }
}
